<?php

/* $Id: drag_manager_sitemap.php 1975 2008-04-18 12:21:23Z chelout $ */
/**
  *  D&D:
  *  - subdivision to subdivision
  *  - subdivision to site
  *  - site to site
  */

ob_start("ob_gzhandler");

define("NC_ADMIN_ASK_PASSWORD", false);

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -4 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
include_once ($NETCAT_FOLDER."vars.inc.php");
require ($ADMIN_FOLDER."function.inc.php");

$dragged_id = (int)$dragged_id; if (!$dragged_id) die("0 /* Wrong parameters */");
$target_id =  (int)$target_id;  if (!$target_id)  die("0 /* Wrong parameters */");

$is_supervisor = ($perm->isSupervisor() || $perm->isManager());

// INPUT: $dragged_type, $dragged_id, $target_type, $target_id, $position [inside|below]
// dropped subdivision on another subdivision or to the site
if ($dragged_type=='sub' && ($target_type=='sub' || $target_type=='site')) {

  // dragged sub info
  $dragged = $db->get_row("SELECT * FROM Subdivision WHERE Subdivision_ID=$dragged_id", ARRAY_A);

  // target (sub or site) info
  if ($target_type=='sub') {
    $target = $db->get_row("SELECT * FROM Subdivision WHERE Subdivision_ID=$target_id",  ARRAY_A);
  }
  elseif  ($target_type=='site') {
    $target = array('Catalogue_ID' => $target_id,
                    'Hidden_URL' => '/',
                    'Parent_Sub_ID' => 0,
                    'Subdivision_ID' => 0
                   );
  }

  if (!$dragged || !$target) { die("0 /* Wrong IDs */"); }

  if (!$is_supervisor) {

    // check rights for dragged object
    if (!$perm->isCatalogueAdmin($dragged['Catalogue_ID']) &&
        !$perm->isSubdivisionAdmin($dragged['Subdivision_ID'])) {
      die("0 /* No sufficient rights for dragged $dragged_type $dragged_id */");
    }

    // check rights for target object
    if ($target_type=='sub' &&
        !$perm->isCatalogueAdmin($target['Catalogue_ID']) &&
        !$perm->isSubdivisionAdmin($target['Subdivision_ID'])) {
      die("0 /* No sufficient rights for target $target_type $target_id */");
    }
    elseif ($target_type=='site' &&
            !$perm->isCatalogueAdmin($target_id)) {
      die("0 /* No sufficient rights for $target_type $target_id */");
    }
  } // of not supervisor

  if ($position=='inside') {
    $priority = 0;
    $parent_sub = $target['Subdivision_ID'];
  }
  elseif ($position=='below') {
    $priority = $target['Priority'];
    if ($target['Parent_Sub_ID'] != $dragged['Parent_Sub_ID']) { $priority++; }
    $parent_sub = $target['Parent_Sub_ID'];
  }
  else {
    die("0 /* Wrong parameter $position=$position */");
  }

  if ($dragged['Parent_Sub_ID'] == $parent_sub) {  // changing priority, but not the parent
    if ($target['Priority'] > $dragged['Priority']) { // moving item downwards
      $db->query("UPDATE Subdivision
                     SET Priority = Priority-1
                   WHERE Parent_Sub_ID = $parent_sub
                     AND Priority BETWEEN $dragged[Priority] AND $priority
                     AND Subdivision_ID != $dragged[Subdivision_ID]");
    }
    else { // moving item upwards
      if ($priority != 0 || $position=='below') $priority = $target['Priority'] + 1;
      $db->query("UPDATE Subdivision
                     SET Priority = Priority+1
                   WHERE Parent_Sub_ID = $parent_sub
                     AND Priority BETWEEN $priority AND $dragged[Priority]
                     AND Subdivision_ID != $dragged[Subdivision_ID]");
    }
  }
  else { // parent has changed
    // make room for inserted/moved node at the new parent
    $db->query("UPDATE Subdivision
                   SET Priority = Priority+1
                 WHERE Parent_Sub_ID = $parent_sub
                   AND Priority >= $priority");

    // collapse gap at the old parent subdivision
    $db->query("UPDATE Subdivision
                   SET Priority = Priority-1
                 WHERE Parent_Sub_ID = $dragged[Parent_Sub_ID]
                   AND Priority > $dragged[Priority]
                   AND Subdivision_ID != $dragged[Subdivision_ID]");

    // update hidden url
    // REPLACE() was not used because there's no way to match from the first symbol
    $old_length = strlen(preg_replace("#[^/]+/$#", "", $dragged['Hidden_URL'])) + 1;
    $new_parent_url = $target["Hidden_URL"];
    if ($position == 'below') { // target's parent
      $new_parent_url = preg_replace("#[^/]+/$#", "", $new_parent_url);
    }

    $db->query("UPDATE Subdivision
                   SET Hidden_URL = CONCAT('$new_parent_url',
                                           SUBSTRING(Hidden_URL FROM $old_length))
                 WHERE Hidden_URL LIKE '$dragged[Hidden_URL]%'");
  }

  // move subdivision
  $db->query("UPDATE Subdivision
                 SET Parent_Sub_ID = $parent_sub,
                     Catalogue_ID = $target[Catalogue_ID],
                     Priority = $priority
               WHERE Subdivision_ID = $dragged[Subdivision_ID]");

  $db->query("UPDATE Sub_Class
                 SET Catalogue_ID = $target[Catalogue_ID]
               WHERE Subdivision_ID = $dragged[Subdivision_ID]");

  if ($target_type=='site' && ($target[Catalogue_ID] != $dragged[Catalogue_ID])) {
	$parent_subs_array = nc_get_subdivision_children($dragged[Subdivision_ID]);
	
	if ($parent_subs_array) {
	  $db->query("UPDATE Subdivision
	                 SET Catalogue_ID = $target[Catalogue_ID]
	               WHERE Subdivision_ID IN (".join(', ', $parent_subs_array).")");
	  $db->query("UPDATE Sub_Class
	                 SET Catalogue_ID = $target[Catalogue_ID]
	               WHERE Subdivision_ID IN (".join(', ', $parent_subs_array).")");
	}

  }

  die("1 /* OK */");
}

if ($dragged_type=='site' && $target_type=='site') {

  // dragged site info
  $dragged = $db->get_row("SELECT Priority FROM Catalogue WHERE Catalogue_ID=$dragged_id", ARRAY_A);

  // target site info
  $target = $db->get_row("SELECT Priority FROM Catalogue WHERE Catalogue_ID=$target_id",  ARRAY_A);

  if ($is_supervisor || ($perm->isCatalogueAdmin($dragged_id) && $perm->isCatalogueAdmin($target_id))) {

    if ($dragged_id <= $target_id) {
      $db->query("UPDATE Catalogue
                     SET Priority = (Priority - 1)
                   WHERE Priority > ".$dragged['Priority']." AND Priority <= ".$target['Priority']);
      $db->query("UPDATE Catalogue
                     SET Priority = ".$target['Priority']."
                   WHERE Catalogue_ID = $dragged_id");
    } else {
      $db->query("UPDATE Catalogue
                     SET Priority = (Priority + 1)
                   WHERE Priority > ".$target['Priority']." AND Priority < ".$dragged['Priority']);
      $db->query("UPDATE Catalogue
                     SET Priority = (".$target['Priority']." + 1)
                   WHERE Catalogue_ID = $dragged_id");

    }

  }

  die("1 /* OK */");
}

// dropped subclass on subdivision
if ($dragged_type=='subclass' && $target_type=='sub') {
  $ret = nc_move_subclass($dragged_id, $target_id);
  die((int)$ret . "/**/");
}


die("0 /* Wrong request ['$dragged_type $dragged_id' $position '$target_type $target_id'] */");

?>